//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup Tool "FUNSSEL" developed for the 
// Simulator League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public 
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

#ifndef CONTROLLED_PROCESS_H
#define CONTROLLED_PROCESS_H

class ControlledProcess {
  char **command;
  char *workdir;

  int pid;

public:
  ControlledProcess();
  ControlledProcess(const char *command[], const char *workdir = 0);
  ~ControlledProcess();

  /// returns true if process is stopped or non existent
  bool stop();
  /// returns true if process is running again
  bool cont();
  /// returns true if process is terminated or non existent
  bool term();
  /// returns true if process is killed or non existent
  bool kill();

  /// command = NULL means reuse old command
  bool restart(const char *command[] = 0, const char *workdir = 0);

  /// check if process is up
  int processOk();

  int  getPID() const { return pid; }
private:
  void start();
  bool sendSignal(int signal);
};
#endif
