//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//
// OnlineCoach - simple online coach
//
// Time-stamp: <00/08/10 18:19:24 goetz>
//
//////////////////////////////////////////////////////////////////////

#include "mrbcoach.h"

#include <stdlib.h>
#include <unistd.h>
#include <iostream.h>

#include "constants.h"

int main (int argc, char *argv[])
{
  char *teamname= "MRB";
  char *host= "localhost" ;
  int port= OLCOACH_PORT;
  bool logging= false;
  bool FUNSSELmode = false;
  char *configfile= "agent.conf";

  char c;
  while ((c= getopt( argc, argv, "Ft:h:p:lf:")) != EOF ) {
    switch (c) {
    case 't':
      teamname= optarg;
      break;
    case 'h':
      host= optarg;
      break;
    case 'p':
      port= atoi(optarg);
      break;
    case 'l':
      logging= true;
      break;
    case 'F':
      FUNSSELmode= true;
      break;
    case 'f':
      configfile= optarg;
      break;
    case '?':
    default:
    cerr << "Usage: " << argv[0] << "[-t TEAMNAME] [-h HOSTNAME]"
	 << "[-p PORTNO] [-l] [-f FILENAME]"
	 << endl
	 << " -l  enable logging" << endl
	 << " -F  enable FUNSSEL mode" << endl
      	 << " -f  FILENAME  alternative configuration file for tactics (default agent.conf)" << endl
	 << endl;
      exit(1);
    }
  }

  cerr << "Mainz Rolling Brains RoboCup Online Coach" << endl
       << "copyright 1998, 1999, 2000, 2001 by the Mainz Rolling Brains team" 
       << endl;


#ifdef RANDSUBS
  cerr << "****** Test mode for heterogenous players activated." << endl
       << "Doing random substitutions." << endl;
#endif 

  MrbCoach *mrbc= new MrbCoach(teamname, host, port, logging, 
			       configfile, FUNSSELmode);

  mrbc->coach();
  
  delete mrbc;

} // main()
