//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

#ifndef __PositionFunctions_H_
#define __PositionFunctions_H_

#include "grade.h"

#include "worldmodel.h"
#include "tacticalmodule.h"
#include "audiomgr.h"
#include "AdvSkills.h"
#include "goalshoteval.h"
#include "passeval.h"
#include "Config.h"

#define Triangle(max,dist,pos) (fabs(pos)<fabs(dist)?(max)-fabs((pos)*((max)/(dist))):0)
			    
#define Step(X1,X2,pos) ((pos)<(X1)?1:((pos)>(X2)?0:(1-(((pos)-(X1))/((X2)-(X1))))))


struct PlayerPos {
  Vector2d Pos; // desired position of a player
  //the x-value should be betwen zero (our offsideline) and 100 
  //(opponent's offsideline) the y-value should be between -FIELD_WIDTH/2 
  //and  FIELD_WIDTH/2

  double ballforceX;
  double ballforceY;
  //strength of the force with which the player is pulled to the ball

  Vector2d Min;
  Vector2d Max;
  //area covered by this player

  int Watches[3];
  //which players have to be replaced, if they are absent

  //int job;
  //what has a player to do in this position? (defender, offender ..)

};


#endif //__PositionFunctions_H_


















